//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;

namespace Testing
{
	interface IFunctions
	{
		void A();
		void B();
		void C();
	}
	abstract class Function : IFunctions
	{
		public void A()
		{
			Console.WriteLine("I am in A");
		}
		public abstract void B();
		public abstract void C();
	}

	// Abstract class
	abstract class Point
	{
		protected int x = 0; 
		protected int y = 0;
		// Abstract methods
		public abstract void Increment();
		public abstract void Decrement();

		// Abstract properties
		public abstract int X
		{
			get;
		}

		public abstract int Y
		{
			get;
		}
	}

	class NewPoint: Point
	{
		public override void Increment() 
		{
			x++;
			y++;   
		}   
		public override void Decrement() 
		{
			x--;
			y--;   
		}   

		public override int X
		{
			get 
			{
				return x;
			}
		}

		public override int Y
		{
			get
			{
				return y;
			}
		}
	}

	class NewFunction : Function
	{
		public override void B()
		{
			Console.WriteLine("I am in B");
		}
		public override void C()
		{
			Console.WriteLine("I am in C");
		}
	}

	class AbstractMain
	{
		public static void Main() 
		{
			NewPoint p = new NewPoint();
			p.Increment();
			p.Increment();
			p.Decrement();
			Console.WriteLine("x = {0}, y = {1}", p.X, p.Y);
			NewFunction f = new NewFunction();
			IFunctions i = (IFunctions)f;
			i.A();
			i.B();
			i.C();
		}
	}
}