//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;

namespace Testing
{
	class CheckedMain
	{
		static short x = Int16.MaxValue;
		static short y = Int16.MaxValue;
		static int AddShort()
		{
			int ret = 0;
			try
			{
				ret = (short)(x + y);
			}
			catch(Exception e)
			{
				Console.WriteLine(e);
			}
			return ret;
		}
		static int AddCheckedShort()
		{
			int ret = 0;
			try
			{
				ret = checked((short)(x + y));
			}
			catch(Exception e)
			{
				Console.WriteLine("Checked:");
				Console.WriteLine(e);
			}
			return ret;
		}
		static int AddUncheckedShort()
		{
			int ret = 0;
			try
			{
				ret = unchecked((short)(x + y));
			}
			catch(Exception e)
			{
				Console.WriteLine("Unchecked:");
				Console.WriteLine(e);
			}
			return ret;
		}
		public static void Main() 
		{
			const int c1 = 5;
			Console.WriteLine("AddShort returns: {0}", AddShort());
			Console.WriteLine("AddCheckedShort returns: {0}", AddCheckedShort());
			Console.WriteLine("AddUncheckedShort returns: {0}", AddUncheckedShort());
			c1++;
		}
	}
}