//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;

namespace Testing
{
	struct Complex
	{
		double real;
		double imag;
		public Complex(double real, double imag)
		{
			this.real = real;
			this.imag = imag;
		}
		public override string ToString()
		{
			return (string.Format("({0}, {1}i)", real, imag));
		}
		public static explicit operator Complex(double r)
		{
			return new Complex(r, 0);
		}
		public static implicit operator Complex(double [] n)
		{
			if(n.Length != 2)
				throw new ArgumentException();
			return new Complex(n[0], n[1]);
		}
	}
	
	class ExplicitMain
	{
		static void Main(string[] args)
		{
			Complex cn = new Complex(1,0);
			Console.WriteLine("{0}", cn);
			cn = (Complex)2;
			Console.WriteLine("{0}", cn);
			double [] da = new double [] {3,0};
			cn = da;
			Console.WriteLine("{0}", cn);
		}
	}
}
