//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
namespace Testing
{
	interface ICommunicate
	{
		void Speak(string s);
		void Listen(string s);
		void Read(string s);
		void Write(string s);
	}
	interface ITravel
	{
		void Walk();
		void Car();
		void Train();
		void Plane();
	}
	class Activities: ICommunicate, ITravel
	{
		// ICommunicate
		public void Speak(string s)
		{
			Console.WriteLine("I said, \"{0}\".", s);
		}
		public void Listen(string s)
		{
			Console.WriteLine("I heard you say, \"{0}\".", s);
		}
		public void Read(string s)
		{
			Console.WriteLine("I just read, \"{0}\".", s);
		}
		public void Write(string s)
		{
			Console.WriteLine("I just wrote, \"{0}\".", s);
		}
		// ITravel
		public void Walk()
		{
			Console.WriteLine("I am walking.");
		}
		public void Car()
		{
			Console.WriteLine("I riding in a car.");
		}
		public void Train()
		{
			Console.WriteLine("I riding in a train.");
		}
		public void Plane()
		{
			Console.WriteLine("I riding in a plane.");
		}
	}
	class InterfaceMain
	{
		static void Main(string[] args)
		{
			Activities a = new Activities();
			try
			{
				IComparable ic = (IComparable)a;
			}
			catch(Exception e)
			{
				Console.WriteLine(e);
			}
			if(a is ICommunicate)
			{
				ICommunicate ac = (ICommunicate)a;
				ac.Speak("I said that");
				ac.Listen("I am talking to you");
				ac.Read("The quick brown fox jumped over the lazy cow.");
				ac.Write("What I did on my summer vacation.");
			}
			if(a is ITravel)
			{
				ITravel at = (ITravel)a;
				at.Walk();
				at.Car();
				at.Train();
				at.Plane();
			}
			Console.WriteLine("--------------------------");
			ICommunicate c = a as ICommunicate;
			if(c != null)
			{
				c.Speak("I said that");
				c.Listen("I am talking to you");
				c.Read("The quick brown fox jumped over the lazy cow.");
				c.Write("What I did on my summer vacation.");
			}
			ITravel t = a as ITravel;
			if(t != null)
			{
				t.Walk();
				t.Car();
				t.Train();
				t.Plane();
			}
		}
	}
}
